"use strict";
var UnoverlayVue = (() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
    get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
  }) : x)(function(x) {
    if (typeof require !== "undefined")
      return require.apply(this, arguments);
    throw new Error('Dynamic require of "' + x + '" is not supported');
  });
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

  // src/index.ts
  var src_exports = {};
  __export(src_exports, {
    createOverlay: () => createOverlay,
    default: () => src_default,
    executeOverlay: () => executeOverlay,
    install: () => install,
    useOverlayMeta: () => useOverlayMeta
  });

  // src/internal/index.ts
  var context = {
    appContext: null
  };
  var OverlayMetaKey = Symbol("__imperative_overlay_key");

  // src/meta.ts
  var import_vue_demi = __require("vue-demi");
  var import_delay = __toESM(__require("delay"));
  var import_noop = __toESM(__require("lodash/noop"));
  var import_core = __require("@vueuse/core");
  function useOverlayMeta(options = {}) {
    const { animation = 0, immediate = true, model = "visible" } = options;
    const defaultMeta = getTemplateMeta(model);
    const meta = (0, import_vue_demi.inject)(OverlayMetaKey, defaultMeta) || defaultMeta;
    !meta.isTemplate && (0, import_vue_demi.watch)(meta.visible, async () => {
      var _a;
      if (meta.visible.value)
        return void 0;
      if (animation > 0)
        await (0, import_delay.default)(animation);
      (_a = meta.vanish) == null ? void 0 : _a.call(meta);
    });
    if (immediate)
      (0, import_vue_demi.onMounted)(() => meta.visible.value = true);
    (0, import_vue_demi.provide)(OverlayMetaKey, null);
    return meta;
  }
  function getTemplateMeta(model) {
    const instance = (0, import_vue_demi.getCurrentInstance)();
    const visible = instance ? (0, import_core.useVModel)(instance.props, model) : (0, import_vue_demi.ref)(false);
    const cancel = (value) => {
      visible.value = false;
      instance == null ? void 0 : instance.emit("cancel", value);
    };
    const confirm = (value) => {
      visible.value = false;
      instance == null ? void 0 : instance.emit("confirm", value);
    };
    return {
      cancel,
      confirm,
      vanish: import_noop.default,
      visible,
      isTemplate: true
    };
  }

  // src/transform.ts
  var import_vue2 = __require("vue");

  // src/helper/render.ts
  var import_vue = __require("vue");
  var renderInstance = (component, props, options = {}) => {
    const vanish = () => {
      (0, import_vue.render)(null, container);
    };
    const Provider = (0, import_vue.defineComponent)({
      name: component.name,
      setup() {
        var _a;
        (_a = options.setup) == null ? void 0 : _a.call(options, vnode, vanish);
      },
      render() {
        return (0, import_vue.h)(component, props);
      }
    });
    const container = document.createElement("div");
    const vnode = (0, import_vue.createVNode)(Provider, props);
    if (context.appContext)
      vnode.appContext = context.appContext;
    if (options.appContext)
      vnode.appContext = options.appContext;
    (0, import_vue.render)(vnode, container);
    if (container.firstElementChild) {
      const root = options.root || document.body;
      root.append(container.firstElementChild);
    }
    return { vanish, vnode };
  };

  // src/transform.ts
  function createOverlay(component) {
    const executor = (props, promiser, mountOptions) => {
      const { reject, resolve, promise } = promiser;
      renderInstance(component, props, {
        appContext: mountOptions == null ? void 0 : mountOptions.appContext,
        root: mountOptions == null ? void 0 : mountOptions.root,
        setup: (vnode, _vanish) => {
          const visible = (0, import_vue2.ref)(false);
          function cancel(value) {
            reject == null ? void 0 : reject(value);
            visible.value = false;
          }
          function confirm(value) {
            resolve == null ? void 0 : resolve(value);
            visible.value = false;
          }
          function vanish() {
            _vanish == null ? void 0 : _vanish();
            reject == null ? void 0 : reject();
          }
          promise.confirm = confirm;
          promise.cancel = cancel;
          (0, import_vue2.provide)(OverlayMetaKey, {
            cancel,
            confirm,
            vanish,
            visible,
            vnode
          });
        }
      });
    };
    const caller = (props, options) => {
      const promiser = createPromiser();
      const notAllowedError = function() {
        throw new Error("createOverlay - Error: It is not allowed to call confirm and cancel externally immediately, please wait for the component to render");
      };
      promiser.promise.confirm = notAllowedError;
      promiser.promise.cancel = notAllowedError;
      executor(props, promiser, options);
      return promiser.promise;
    };
    return caller;
  }
  function createPromiser() {
    let resolve;
    let reject;
    const promise = new Promise((_resolve, _reject) => {
      resolve = _resolve;
      reject = _reject;
    });
    return { promise, reject, resolve };
  }

  // src/utils.ts
  function executeOverlay(component, options) {
    return createOverlay(component)(options == null ? void 0 : options.props, options);
  }

  // src/index.ts
  var install = (app) => {
    context.appContext = app._context;
  };
  var unoverlay = { install };
  var src_default = unoverlay;
  return __toCommonJS(src_exports);
})();
//# sourceMappingURL=index.iife.js.map
